package de.intevation.flys.importer;

import java.util.ArrayList;
import java.util.List;

import org.hibernate.Session;
import org.hibernate.Query;

import de.intevation.flys.model.DischargeTable;
import de.intevation.flys.model.Gauge;


public class ImportDischargeTable
{
    protected DischargeTable peer;

    protected Integer kind;

    protected List<ImportDischargeTableValue> dischargeTableValues;


    public ImportDischargeTable() {
        kind = 0;
        dischargeTableValues = new ArrayList<ImportDischargeTableValue>();
    }


    public void addDischargeTableValue(ImportDischargeTableValue value) {
        dischargeTableValues.add(value);
    }


    public void setDischargeTableValues(List<ImportDischargeTableValue> values){
        this.dischargeTableValues = values;
    }


    public List<ImportDischargeTableValue> getDischargeTableValues() {
        return dischargeTableValues;
    }


    public DischargeTable getPeer(Gauge gauge) {
        if (peer == null) {
            Session session = Importer.sessionHolder.get();

            Query query = session.createQuery(
                "from DischargeTable where gauge.id=:gauge");
            query.setParameter("gauge", gauge.getId());
            query.setParameter("kind", kind);

            List<DischargeTable> dischargeTables = query.list();
            if (dischargeTables.isEmpty()) {
                peer = new DischargeTable(gauge, kind);
                session.save(peer);
            }
            else {
                peer = dischargeTables.get(0);
            }
        }

        return peer;
    }


    public void storeDependencies(Gauge gauge) {
        storeDischargeTableValues(gauge);
    }


    public void storeDischargeTableValues(Gauge gauge) {
        DischargeTable dischargeTable = getPeer(gauge);

        for (ImportDischargeTableValue value: dischargeTableValues) {
            value.getPeer(dischargeTable);
        }
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
